/* [cdps_lim.c] Scanner table for 'cdps'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[53] =
/* first edge per state */
{
    0,  10,  11,  24,  27,  32,  45,  48,  51,  54,
   57,  70,  76,  79,  82,  85,  88,  92, 104, 112,
  118, 124, 125, 128, 135, 138, 141, 144, 150, 156,
  162, 169, 172, 178, 184, 190, 191, 194, 200, 206,
  216, 219, 226, 233, 239, 244, 253, 262, 269, 270,
  271, 278, 279
};

static short StaFin[52] =
/* finite token per state */
{
    0,   6,   6,   6,   6,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   5,   5,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   4,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   2,   3,
    0,   1
};

static wc_char EdgeC[279] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        256,         48,         47,         36,         35,         14,         13,         11,
                    10,          0,
  /*   1 */          0,
  /*   2 */        119,        118,        110,        109,        106,        105,         33,         32,
                    14,         13,         11,          9,          0,
  /*   3 */        106,        105,          0,
  /*   4 */         48,         47,         43,         42,          0,
  /*   5 */        119,        118,        110,        109,        106,        105,         33,         32,
                    14,         13,         11,          9,          0,
  /*   6 */        111,        110,          0,
  /*   7 */         98,         97,          0,
  /*   8 */        112,        111,          0,
  /*   9 */        111,        110,          0,
  /*  10 */        256,        110,        109,         43,         42,         34,         33,         32,
                    14,         13,         11,          9,          0,
  /*  11 */        256,         14,         13,         11,         10,          0,
  /*  12 */        117,        116,          0,
  /*  13 */        106,        105,          0,
  /*  14 */        106,        105,          0,
  /*  15 */        100,         99,          0,
  /*  16 */        256,         43,         42,          0,
  /*  17 */        256,        110,        109,         43,         42,         33,         32,         14,
                    13,         11,          9,          0,
  /*  18 */        256,         83,         82,         77,         76,         43,         42,          0,
  /*  19 */        256,         48,         47,         43,         42,          0,
  /*  20 */        256,         98,         97,         43,         42,          0,
  /*  21 */          0,
  /*  22 */         11,         10,          0,
  /*  23 */        110,        109,         33,         32,         10,          9,          0,
  /*  24 */        111,        110,          0,
  /*  25 */        101,        100,          0,
  /*  26 */        109,        108,          0,
  /*  27 */        256,         74,         73,         43,         42,          0,
  /*  28 */        256,         70,         69,         43,         42,          0,
  /*  29 */        256,        106,        105,         43,         42,          0,
  /*  30 */         41,         40,         33,         32,         10,          9,          0,
  /*  31 */        118,        117,          0,
  /*  32 */        256,         67,         66,         43,         42,          0,
  /*  33 */        256,         84,         83,         43,         42,          0,
  /*  34 */        256,        111,        110,         43,         42,          0,
  /*  35 */          0,
  /*  36 */        101,        100,          0,
  /*  37 */        256,         59,         58,         43,         42,          0,
  /*  38 */        256,         59,         58,         43,         42,          0,
  /*  39 */        256,         43,         42,         33,         32,         14,         13,         11,
                     9,          0,
  /*  40 */        102,        101,          0,
  /*  41 */        256,        128,        127,         43,         42,         33,          0,
  /*  42 */        256,        128,        127,         43,         42,         33,          0,
  /*  43 */        256,         48,         47,         43,         42,          0,
  /*  44 */         33,         32,         10,          9,          0,
  /*  45 */        256,        128,        127,         48,         47,         43,         42,         33,
                     0,
  /*  46 */        256,        128,        127,         48,         47,         43,         42,         33,
                     0,
  /*  47 */         35,         34,         33,         32,         10,          9,          0,
  /*  48 */          0,
  /*  49 */          0,
  /*  50 */        256,        128,        127,         35,         34,         33,          0,
  /*  51 */          0
};

static short EdgeS[279] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   2,   5,   2,   4,   2,   3,   2,   3,   2,
  /*   1 */   0,
  /*   2 */   0,   9,   0,   8,   0,   7,   0,   6,   0,   6,
              0,   6,   0,
  /*   3 */   0,  10,   0,
  /*   4 */   0,  12,   0,  11,   0,
  /*   5 */   0,   9,   0,   8,   0,   7,   0,   6,   0,   6,
              0,   6,   0,
  /*   6 */   0,  13,   0,
  /*   7 */   0,  14,   0,
  /*   8 */   0,  15,   0,
  /*   9 */   0,  16,   0,
  /*  10 */   0,  17,  21,  17,  20,  17,  19,  18,  17,  18,
             17,  18,  17,
  /*  11 */   0,  12,  23,  12,  22,  12,
  /*  12 */   0,  24,   0,
  /*  13 */   0,  25,   0,
  /*  14 */   0,  26,   0,
  /*  15 */   0,  27,   0,
  /*  16 */   0,  17,  20,  17,
  /*  17 */   0,  17,  21,  17,  20,  17,  18,  17,  18,  17,
             18,  17,
  /*  18 */   0,  17,  29,  17,  28,  17,  20,  17,
  /*  19 */   0,  17,  22,  17,  20,  17,
  /*  20 */   0,  17,  30,  17,  20,  17,
  /*  21 */   0,
  /*  22 */   0,  22,   0,
  /*  23 */   0,   8,   0,  24,   0,  24,   0,
  /*  24 */   0,  31,   0,
  /*  25 */   0,  24,   0,
  /*  26 */   0,  32,   0,
  /*  27 */   0,  17,  33,  17,  20,  17,
  /*  28 */   0,  17,  34,  17,  20,  17,
  /*  29 */   0,  17,  35,  17,  20,  17,
  /*  30 */   0,  36,   0,  31,   0,  31,   0,
  /*  31 */   0,  37,   0,
  /*  32 */   0,  17,  38,  17,  20,  17,
  /*  33 */   0,  17,  39,  17,  20,  17,
  /*  34 */   0,  17,  40,  17,  20,  17,
  /*  35 */   0,
  /*  36 */   0,  41,   0,
  /*  37 */   0,  17,  42,  17,  20,  17,
  /*  38 */   0,  17,  43,  17,  20,  17,
  /*  39 */   0,  17,  44,  17,  40,  17,  40,  17,  40,  17,
  /*  40 */   0,  45,   0,
  /*  41 */   0,  42,  17,  42,  46,  42,  17,
  /*  42 */   0,  43,  17,  43,  47,  43,  17,
  /*  43 */   0,  17,  36,  17,  20,  17,
  /*  44 */   0,  48,   0,  48,   0,
  /*  45 */   0,  42,  17,  42,  49,  42,  46,  42,  17,
  /*  46 */   0,  43,  17,  43,  50,  43,  47,  43,  17,
  /*  47 */   0,  51,   0,  48,   0,  48,   0,
  /*  48 */   0,
  /*  49 */   0,
  /*  50 */   0,  51,   0,  51,  52,  51,   0,
  /*  51 */   0
};

static string Tokens[7] =
/* token -> string */
{
  "[other]",
  "Include",
  "Library",
  "Resource",
  "Program",
  "Comment",
  "Other"
};

static byte Flags[7] =
/* token -> newid */
{
  0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "cdps", /* Name    */
  52,     /* States  */
   7,     /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_cdps(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
}
