/* [cmd_lim.c] Scanner table for 'cmd'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[97] =
/* first edge per state */
{
    0,  38,  39,  40,  43,  45,  46,  47,  60,  71,
   85,  86,  91,  96,  99, 108, 115, 124, 125, 145,
  150, 155, 160, 163, 166, 181, 182, 204, 209, 210,
  217, 224, 231, 240, 245, 248, 251, 256, 259, 262,
  263, 276, 289, 309, 314, 317, 320, 331, 334, 335,
  338, 341, 344, 347, 357, 360, 363, 366, 369, 374,
  377, 380, 388, 391, 399, 408, 411, 425, 428, 431,
  445, 448, 449, 458, 466, 486, 497, 500, 512, 515,
  532, 536, 541, 544, 561, 569, 581, 584, 594, 600,
  606, 609, 615, 621, 622, 628, 634
};

static short StaFin[96] =
/* finite token per state */
{
    0,   2,   3,   0,   4,   1,   9,   0,  19,   0,
    5,   0,   9,   7,   7,   6,   6,  11,   0,  19,
    0,   0,   0,  17,  17,  10,  17,  14,  12,   8,
    8,   0,   6,   0,   0,   0,   0,   0,   0,  17,
    0,  17,   0,   0,   0,   8,   6,   0,  18,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,  13,  18,   0,  16,   0,   0,  16,   0,   0,
    0,  15,   0,   0,   0,   0,   0,  16,   0,   0,
    0,   0,   0,  16,   0,   0
};

static wc_char EdgeC[634] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        255,        128,        127,        126,        125,        124,        123,        101,
                   100,         97,         96,         94,         93,         92,         91,         65,
                    58,         49,         48,         47,         46,         45,         42,         40,
                    39,         36,         35,         34,         33,         32,         27,         26,
                    14,         13,         12,         11,         10,          0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */         11,         10,          0,
  /*   4 */        256,          0,
  /*   5 */          0,
  /*   6 */          0,
  /*   7 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*   8 */        255,        128,        127,        110,        109,        106,        105,        102,
                   101,         32,          0,
  /*   9 */        256,        255,        128,        127,         97,         96,         93,         92,
                    40,         39,         35,         34,         32,          0,
  /*  10 */          0,
  /*  11 */         58,         48,         46,         45,          0,
  /*  12 */         58,         49,         47,         46,          0,
  /*  13 */         58,         48,          0,
  /*  14 */        102,        101,         70,         69,         58,         48,         47,         46,
                     0,
  /*  15 */        123,         97,         91,         65,         58,         48,          0,
  /*  16 */        123,        112,        111,         97,         91,         65,         58,         48,
                     0,
  /*  17 */          0,
  /*  18 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         40,
                    39,         35,         34,          0,
  /*  19 */        255,        128,        127,         32,          0,
  /*  20 */        111,        110,        109,        108,          0,
  /*  21 */        111,        110,        103,        102,          0,
  /*  22 */         98,         97,          0,
  /*  23 */         46,         45,          0,
  /*  24 */        255,        128,        127,         97,         96,         93,         92,         46,
                    45,         40,         39,         35,         34,         32,          0,
  /*  25 */          0,
  /*  26 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         46,
                    45,         40,         39,         35,         34,          0,
  /*  27 */        255,        128,        127,         32,          0,
  /*  28 */          0,
  /*  29 */        102,        101,         70,         69,         58,         48,          0,
  /*  30 */        102,        101,         70,         69,         58,         49,          0,
  /*  31 */         58,         49,         46,         45,         44,         43,          0,
  /*  32 */        123,        100,         99,         97,         91,         65,         58,         48,
                     0,
  /*  33 */        103,         97,         58,         48,          0,
  /*  34 */        116,        115,          0,
  /*  35 */        101,        100,          0,
  /*  36 */        111,        110,        101,        100,          0,
  /*  37 */        100,         99,          0,
  /*  38 */        100,         99,          0,
  /*  39 */          0,
  /*  40 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*  41 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*  42 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         40,
                    39,         35,         34,          0,
  /*  43 */        103,         97,         58,         48,          0,
  /*  44 */         58,         49,          0,
  /*  45 */         58,         48,          0,
  /*  46 */        123,         97,         91,         65,         58,         48,         14,         13,
                    11,         10,          0,
  /*  47 */        102,        101,          0,
  /*  48 */          0,
  /*  49 */        102,        101,          0,
  /*  50 */        101,        100,          0,
  /*  51 */        109,        108,          0,
  /*  52 */        115,        114,          0,
  /*  53 */        100,         99,         33,         32,         14,         13,         12,         11,
                    10,          0,
  /*  54 */         11,         10,          0,
  /*  55 */        103,        102,          0,
  /*  56 */        118,        117,          0,
  /*  57 */        112,        111,          0,
  /*  58 */         14,         13,         11,         10,          0,
  /*  59 */         33,         32,          0,
  /*  60 */        112,        111,          0,
  /*  61 */         33,         32,         14,         13,         12,         11,         10,          0,
  /*  62 */        101,        100,          0,
  /*  63 */         33,         32,         14,         13,         12,         11,         10,          0,
  /*  64 */        255,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  65 */        101,        100,          0,
  /*  66 */        123,         97,         96,         95,         91,         65,         33,         32,
                    14,         13,         12,         11,         10,          0,
  /*  67 */         11,         10,          0,
  /*  68 */        102,        101,          0,
  /*  69 */        123,         97,         96,         95,         91,         65,         33,         32,
                    14,         13,         12,         11,         10,          0,
  /*  70 */         11,         10,          0,
  /*  71 */          0,
  /*  72 */        123,         97,         96,         95,         91,         65,         58,         48,
                     0,
  /*  73 */         33,         32,         14,         13,         12,         11,         10,          0,
  /*  74 */        123,         97,         96,         95,         91,         65,         62,         61,
                    58,         48,         41,         40,         33,         32,         14,         13,
                    12,         11,         10,          0,
  /*  75 */        255,        128,        127,         33,         32,         14,         13,         12,
                    11,         10,          0,
  /*  76 */         11,         10,          0,
  /*  77 */         62,         61,         41,         40,         33,         32,         14,         13,
                    12,         11,         10,          0,
  /*  78 */         11,         10,          0,
  /*  79 */        255,        128,        127,         62,         61,         45,         44,         42,
                    41,         33,         32,         14,         13,         12,         11,         10,
                     0,
  /*  80 */        256,         36,         35,          0,
  /*  81 */        255,        128,        127,         33,          0,
  /*  82 */         11,         10,          0,
  /*  83 */        255,        128,        127,         62,         61,         45,         44,         42,
                    41,         33,         32,         14,         13,         12,         11,         10,
                     0,
  /*  84 */        256,        110,        109,        102,        101,         36,         35,          0,
  /*  85 */         45,         44,         42,         41,         33,         32,         14,         13,
                    12,         11,         10,          0,
  /*  86 */         11,         10,          0,
  /*  87 */         62,         61,         33,         32,         14,         13,         12,         11,
                    10,          0,
  /*  88 */        256,        111,        110,         36,         35,          0,
  /*  89 */        256,         98,         97,         36,         35,          0,
  /*  90 */         11,         10,          0,
  /*  91 */        256,        101,        100,         36,         35,          0,
  /*  92 */        256,        100,         99,         36,         35,          0,
  /*  93 */          0,
  /*  94 */        256,        115,        114,         36,         35,          0,
  /*  95 */        256,        112,        111,         36,         35,          0
};

static short EdgeS[634] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   7,   0,   7,  11,   7,  11,  16,  17,  16,
              0,   7,  11,   0,  11,  16,   7,  15,  14,   7,
             13,  12,   7,  11,  10,   7,   9,   8,   7,   6,
              0,   5,   0,   4,   3,   0,   2,   0,
  /*   1 */   0,
  /*   2 */   0,
  /*   3 */   0,   2,   0,
  /*   4 */   0,   5,
  /*   5 */   0,
  /*   6 */   0,
  /*   7 */   0,   8,   0,   8,   0,   8,  19,   8,   0,   8,
             18,   8,   0,
  /*   8 */   0,  20,   0,  20,  23,  20,  22,  20,  21,  20,
              0,
  /*   9 */   0,  24,  25,  24,  25,  24,  25,  27,  25,  26,
             25,  24,  25,  24,
  /*  10 */   0,
  /*  11 */   0,  14,   0,  28,   0,
  /*  12 */   0,  30,   0,  29,   0,
  /*  13 */   0,  14,   0,
  /*  14 */   0,  32,   0,  32,   0,  15,   0,  31,   0,
  /*  15 */   0,  16,   0,  16,   0,  16,   0,
  /*  16 */   0,  16,  33,  16,   0,  16,   0,  16,   0,
  /*  17 */   0,
  /*  18 */   0,   8,   0,   8,   0,   8,   0,   8,   0,  34,
              8,   0,   8,   0,  34,   0,   8,   0,   8,   0,
  /*  19 */   0,  20,   0,  20,   0,
  /*  20 */   0,  36,   0,  35,   0,
  /*  21 */   0,  38,   0,  37,   0,
  /*  22 */   0,  39,   0,
  /*  23 */   0,  40,   0,
  /*  24 */   0,  41,   0,  41,   0,  41,  43,  41,  42,  41,
             26,  41,   0,  41,   0,
  /*  25 */   0,
  /*  26 */   0,  41,   0,  41,   0,  41,   0,  41,   0,  44,
             41,   0,  41,   0,  44,   0,  40,   0,  41,   0,
             41,   0,
  /*  27 */   0,  28,   0,  28,   0,
  /*  28 */   0,
  /*  29 */   0,  32,   0,  32,   0,  30,   0,
  /*  30 */   0,  32,   0,  32,   0,  30,   0,
  /*  31 */   0,  46,   0,  45,   0,  45,   0,
  /*  32 */   0,  16,  47,  16,   0,  16,   0,  16,   0,
  /*  33 */   0,   8,   0,   8,   0,
  /*  34 */   0,  48,   0,
  /*  35 */   0,  49,   0,
  /*  36 */   0,  51,   0,  50,   0,
  /*  37 */   0,  52,   0,
  /*  38 */   0,  53,   0,
  /*  39 */   0,
  /*  40 */   0,  41,   0,  41,   0,  41,  43,  41,  26,  41,
              0,  41,   0,
  /*  41 */   0,  41,   0,  41,   0,  41,  43,  41,  26,  41,
              0,  41,   0,
  /*  42 */   0,  41,   0,  41,   0,  41,   0,  41,   0,  44,
             41,   0,  41,   0,  44,   0,  41,   0,  41,   0,
  /*  43 */   0,  41,   0,  41,   0,
  /*  44 */   0,  46,   0,
  /*  45 */   0,  46,   0,
  /*  46 */   0,  16,   0,  16,   0,  16,   0,  55,   0,  54,
              0,
  /*  47 */   0,  49,   0,
  /*  48 */   0,
  /*  49 */   0,  56,   0,
  /*  50 */   0,  50,   0,
  /*  51 */   0,  57,   0,
  /*  52 */   0,  58,   0,
  /*  53 */   0,  61,   0,  60,   0,  55,  59,   0,  54,   0,
  /*  54 */   0,  54,   0,
  /*  55 */   0,  62,   0,
  /*  56 */   0,  63,   0,
  /*  57 */   0,  64,   0,
  /*  58 */   0,  55,   0,  54,   0,
  /*  59 */   0,  65,   0,
  /*  60 */   0,  66,   0,
  /*  61 */   0,  67,   0,  68,  67,   0,  67,   0,
  /*  62 */   0,  69,   0,
  /*  63 */   0,  70,   0,  71,  70,   0,  70,   0,
  /*  64 */   0,  65,   0,  65,   0,  55,   0,  54,   0,
  /*  65 */   0,  72,   0,
  /*  66 */   0,  73,   0,  73,   0,  73,   0,  67,   0,  68,
             67,   0,  67,   0,
  /*  67 */   0,  67,   0,
  /*  68 */   0,  74,   0,
  /*  69 */   0,  75,   0,  75,   0,  75,   0,  70,   0,  71,
             70,   0,  70,   0,
  /*  70 */   0,  70,   0,
  /*  71 */   0,
  /*  72 */   0,  73,   0,  73,   0,  73,   0,  73,   0,
  /*  73 */   0,  76,   0,  77,  76,   0,  76,   0,
  /*  74 */   0,  75,   0,  75,   0,  75,   0,  81,   0,  75,
              0,  80,   0,  78,   0,  79,  78,   0,  78,   0,
  /*  75 */   0,  82,   0,  82,  76,   0,  77,  76,   0,  76,
              0,
  /*  76 */   0,  76,   0,
  /*  77 */   0,  81,   0,  80,   0,  78,   0,  79,  78,   0,
             78,   0,
  /*  78 */   0,  78,   0,
  /*  79 */   0,  84,   0,  84,   0,  84,   0,  84,   0,  84,
             80,   0,  83,  80,   0,  80,   0,
  /*  80 */   0,  81,  85,  81,
  /*  81 */   0,  82,   0,  82,   0,
  /*  82 */   0,  80,   0,
  /*  83 */   0,  84,   0,  84,   0,  84,  80,  84,  88,  84,
             86,   0,  87,  86,   0,  86,   0,
  /*  84 */   0,  81,  90,  81,  89,  81,  85,  81,
  /*  85 */   0,  80,   0,  88,   0,  86,   0,  87,  86,   0,
             86,   0,
  /*  86 */   0,  86,   0,
  /*  87 */   0,  81,   0,  88,   0,  91,  88,   0,  88,   0,
  /*  88 */   0,  81,  92,  81,  85,  81,
  /*  89 */   0,  81,  93,  81,  85,  81,
  /*  90 */   0,  88,   0,
  /*  91 */   0,  81,  94,  81,  85,  81,
  /*  92 */   0,  81,  95,  81,  85,  81,
  /*  93 */   0,
  /*  94 */   0,  81,  96,  81,  85,  81,
  /*  95 */   0,  81,   0,  81,  85,  81
};

static string Tokens[20] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Page",
  "Etx",
  "Parenthesis",
  "Ide",
  "Int",
  "Flo",
  "Opr",
  "Set",
  "Seq",
  "Pth",
  "Doc",
  "Dol",
  "MacInc",
  "MacDfn",
  "MacSep",
  "MacCond",
  "Comment"
};

static byte Flags[20] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "cmd", /* Name    */
  96,    /* States  */
  20,    /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_cmd(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
}
