/* [cprj_lim.c] Scanner table for 'cprj'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[73] =
/* first edge per state */
{
    0,  33,  34,  35,  36,  39,  40,  55,  72,  89,
  108, 112, 121, 122, 125, 134, 139, 144, 147, 165,
  182, 199, 202, 203, 206, 215, 218, 221, 226, 229,
  232, 233, 236, 237, 240, 243, 246, 249, 252, 255,
  258, 266, 269, 277, 291, 294, 297, 311, 314, 323,
  331, 351, 362, 365, 377, 380, 397, 401, 406, 409,
  426, 434, 446, 449, 459, 465, 471, 474, 480, 486,
  487, 493, 499
};

static short StaFin[72] =
/* finite token per state */
{
    0,   1,   2,   3,   0,   5,   5,   5,   5,   4,
    5,   5,   7,   0,   0,   0,   0,   0,   0,   0,
    0,  10,   6,   0,   0,   0,   0,   0,   0,   0,
   10,   0,  11,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,  11,   0,
    9,   0,   0,   9,   0,   0,   0,   8,   0,   0,
    0,   0,   0,   9,   0,   0,   0,   0,   0,   9,
    0,   0
};

static wc_char EdgeC[499] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        256,        128,        127,        126,        125,        124,         97,         96,
                    95,         93,         92,         91,         63,         62,         61,         60,
                    45,         44,         40,         39,         38,         37,         36,         35,
                    33,         32,         14,         13,         12,         11,         10,          9,
                     0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */          0,
  /*   4 */         11,         10,          0,
  /*   5 */          0,
  /*   6 */        256,        128,        127,        110,        109,        106,        105,        102,
                   101,         32,         14,         13,         11,         10,          0,
  /*   7 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*   8 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*   9 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                    37,         36,          0,
  /*  10 */        256,         40,         39,          0,
  /*  11 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  12 */          0,
  /*  13 */         11,         10,          0,
  /*  14 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  15 */        111,        110,        109,        108,          0,
  /*  16 */        111,        110,        103,        102,          0,
  /*  17 */         98,         97,          0,
  /*  18 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                    37,          0,
  /*  19 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*  20 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*  21 */         46,         45,          0,
  /*  22 */          0,
  /*  23 */         11,         10,          0,
  /*  24 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  25 */        116,        115,          0,
  /*  26 */        101,        100,          0,
  /*  27 */        111,        110,        101,        100,          0,
  /*  28 */        100,         99,          0,
  /*  29 */        100,         99,          0,
  /*  30 */          0,
  /*  31 */        102,        101,          0,
  /*  32 */          0,
  /*  33 */        102,        101,          0,
  /*  34 */        101,        100,          0,
  /*  35 */        109,        108,          0,
  /*  36 */        115,        114,          0,
  /*  37 */        103,        102,          0,
  /*  38 */        118,        117,          0,
  /*  39 */        112,        111,          0,
  /*  40 */         33,         32,         14,         13,         12,         11,          9,          0,
  /*  41 */        101,        100,          0,
  /*  42 */         33,         32,         14,         13,         12,         11,          9,          0,
  /*  43 */        123,         97,         96,         95,         91,         65,         33,         32,
                    14,         13,         12,         11,          9,          0,
  /*  44 */         11,         10,          0,
  /*  45 */        102,        101,          0,
  /*  46 */        123,         97,         96,         95,         91,         65,         33,         32,
                    14,         13,         12,         11,          9,          0,
  /*  47 */         11,         10,          0,
  /*  48 */        123,         97,         96,         95,         91,         65,         58,         48,
                     0,
  /*  49 */         33,         32,         14,         13,         12,         11,          9,          0,
  /*  50 */        123,         97,         96,         95,         91,         65,         62,         61,
                    58,         48,         41,         40,         33,         32,         14,         13,
                    12,         11,          9,          0,
  /*  51 */        256,        128,        127,         33,         32,         14,         13,         12,
                    11,          9,          0,
  /*  52 */         11,         10,          0,
  /*  53 */         62,         61,         41,         40,         33,         32,         14,         13,
                    12,         11,          9,          0,
  /*  54 */         11,         10,          0,
  /*  55 */        256,        128,        127,         62,         61,         45,         44,         42,
                    41,         33,         32,         14,         13,         12,         11,          9,
                     0,
  /*  56 */        256,         36,         35,          0,
  /*  57 */        256,        128,        127,         33,          0,
  /*  58 */         11,         10,          0,
  /*  59 */        256,        128,        127,         62,         61,         45,         44,         42,
                    41,         33,         32,         14,         13,         12,         11,          9,
                     0,
  /*  60 */        256,        110,        109,        102,        101,         36,         35,          0,
  /*  61 */         45,         44,         42,         41,         33,         32,         14,         13,
                    12,         11,          9,          0,
  /*  62 */         11,         10,          0,
  /*  63 */         62,         61,         33,         32,         14,         13,         12,         11,
                     9,          0,
  /*  64 */        256,        111,        110,         36,         35,          0,
  /*  65 */        256,         98,         97,         36,         35,          0,
  /*  66 */         11,         10,          0,
  /*  67 */        256,        101,        100,         36,         35,          0,
  /*  68 */        256,        100,         99,         36,         35,          0,
  /*  69 */          0,
  /*  70 */        256,        115,        114,         36,         35,          0,
  /*  71 */        256,        112,        111,         36,         35,          0
};

static short EdgeS[499] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   6,   0,  12,  10,   6,  10,   6,  10,   6,
             10,   6,  10,   6,  12,   6,  10,   6,  10,  11,
             10,   9,   8,   7,   6,   2,   0,   5,   4,   0,
              3,   2,   0,
  /*   1 */   0,
  /*   2 */   0,
  /*   3 */   0,
  /*   4 */   0,   3,   0,
  /*   5 */   0,
  /*   6 */   0,  15,   0,  15,  18,  15,  17,  15,  16,  15,
              0,  14,   0,  13,   0,
  /*   7 */   0,  10,   0,  10,   0,  10,   0,  10,   0,  10,
              0,  10,   0,  10,   0,  10,   0,
  /*   8 */   0,  19,   0,  19,   0,  19,   0,  19,   0,  19,
              0,  19,   0,  19,   0,  19,   0,
  /*   9 */   0,  10,   0,  10,   0,  10,   0,  10,   0,  10,
              0,  10,   0,  10,   0,  10,  21,  20,   0,
  /*  10 */   0,  22,   0,  22,
  /*  11 */   0,  25,   0,  25,   0,  24,   0,  23,   0,
  /*  12 */   0,
  /*  13 */   0,  13,   0,
  /*  14 */   0,  15,   0,  15,   0,  14,   0,  13,   0,
  /*  15 */   0,  27,   0,  26,   0,
  /*  16 */   0,  29,   0,  28,   0,
  /*  17 */   0,  30,   0,
  /*  18 */   0,  19,   0,  19,   0,  19,   0,  19,   0,  19,
              0,  19,   0,  19,   0,  19,  10,   0,
  /*  19 */   0,  10,   0,  10,   0,  10,   0,  10,   0,  10,
              0,  10,   0,  10,   0,  10,   0,
  /*  20 */   0,  19,   0,  19,   0,  19,   0,  19,   0,  19,
              0,  19,   0,  19,   0,  19,   0,
  /*  21 */   0,  31,   0,
  /*  22 */   0,
  /*  23 */   0,  23,   0,
  /*  24 */   0,  25,   0,  25,   0,  24,   0,  23,   0,
  /*  25 */   0,  32,   0,
  /*  26 */   0,  33,   0,
  /*  27 */   0,  35,   0,  34,   0,
  /*  28 */   0,  36,   0,
  /*  29 */   0,  37,   0,
  /*  30 */   0,
  /*  31 */   0,  33,   0,
  /*  32 */   0,
  /*  33 */   0,  38,   0,
  /*  34 */   0,  34,   0,
  /*  35 */   0,  39,   0,
  /*  36 */   0,  40,   0,
  /*  37 */   0,  41,   0,
  /*  38 */   0,  42,   0,
  /*  39 */   0,  43,   0,
  /*  40 */   0,  44,   0,  45,  44,   0,  44,   0,
  /*  41 */   0,  46,   0,
  /*  42 */   0,  47,   0,  48,  47,   0,  47,   0,
  /*  43 */   0,  49,   0,  49,   0,  49,   0,  44,   0,  45,
             44,   0,  44,   0,
  /*  44 */   0,  44,   0,
  /*  45 */   0,  50,   0,
  /*  46 */   0,  51,   0,  51,   0,  51,   0,  47,   0,  48,
             47,   0,  47,   0,
  /*  47 */   0,  47,   0,
  /*  48 */   0,  49,   0,  49,   0,  49,   0,  49,   0,
  /*  49 */   0,  52,   0,  53,  52,   0,  52,   0,
  /*  50 */   0,  51,   0,  51,   0,  51,   0,  57,   0,  51,
              0,  56,   0,  54,   0,  55,  54,   0,  54,   0,
  /*  51 */   0,  58,   0,  58,  52,   0,  53,  52,   0,  52,
              0,
  /*  52 */   0,  52,   0,
  /*  53 */   0,  57,   0,  56,   0,  54,   0,  55,  54,   0,
             54,   0,
  /*  54 */   0,  54,   0,
  /*  55 */   0,  60,   0,  60,   0,  60,   0,  60,   0,  60,
             56,   0,  59,  56,   0,  56,   0,
  /*  56 */   0,  57,  61,  57,
  /*  57 */   0,  58,   0,  58,   0,
  /*  58 */   0,  56,   0,
  /*  59 */   0,  60,   0,  60,   0,  60,  56,  60,  64,  60,
             62,   0,  63,  62,   0,  62,   0,
  /*  60 */   0,  57,  66,  57,  65,  57,  61,  57,
  /*  61 */   0,  56,   0,  64,   0,  62,   0,  63,  62,   0,
             62,   0,
  /*  62 */   0,  62,   0,
  /*  63 */   0,  57,   0,  64,   0,  67,  64,   0,  64,   0,
  /*  64 */   0,  57,  68,  57,  61,  57,
  /*  65 */   0,  57,  69,  57,  61,  57,
  /*  66 */   0,  64,   0,
  /*  67 */   0,  57,  70,  57,  61,  57,
  /*  68 */   0,  57,  71,  57,  61,  57,
  /*  69 */   0,
  /*  70 */   0,  57,  72,  57,  61,  57,
  /*  71 */   0,  57,   0,  57,  61,  57
};

static string Tokens[12] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Page",
  "Name",
  "Opr",
  "Val",
  "Comment",
  "MacInc",
  "MMacDfn",
  "MacSep",
  "MacCond"
};

static byte Flags[12] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "cprj", /* Name    */
  72,     /* States  */
  12,     /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_cprj(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
}
