/* [esty_lim.c] Scanner table for 'estyx'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[21] =
/* first edge per state */
{
    0,  33,  34,  35,  38,  40,  41,  60,  73,  86,
   87,  90,  95, 102, 103, 123, 124, 144, 147, 152,
  157
};

static short StaFin[20] =
/* finite token per state */
{
    0,   2,   3,   0,   4,   1,   9,   0,   0,   5,
    8,   6,   7,  11,   0,  10,   0,   7,   0,   0
};

static wc_char EdgeC[157] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        255,        128,        127,        126,        125,        124,        123,         97,
                    96,         94,         93,         92,         91,         65,         60,         59,
                    58,         48,         42,         40,         39,         35,         34,         33,
                    32,         27,         26,         14,         13,         12,         11,         10,
                     0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */         11,         10,          0,
  /*   4 */        256,          0,
  /*   5 */          0,
  /*   6 */        255,        128,        127,        126,        125,        124,         96,         94,
                    65,         60,         59,         58,         48,         42,         39,         35,
                    34,         33,          0,
  /*   7 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*   8 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*   9 */          0,
  /*  10 */         58,         48,          0,
  /*  11 */        255,        128,        127,         32,          0,
  /*  12 */        123,         97,         91,         65,         58,         48,          0,
  /*  13 */          0,
  /*  14 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         40,
                    39,         35,         34,          0,
  /*  15 */          0,
  /*  16 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         40,
                    39,         35,         34,          0,
  /*  17 */         58,         48,          0,
  /*  18 */        103,         97,         58,         48,          0,
  /*  19 */        103,         97,         58,         48,          0
};

static short EdgeS[157] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   7,   0,   7,  10,   7,  10,  13,   0,   7,
             10,   0,  10,  13,   7,  12,   7,  11,   7,  10,
              9,   7,   8,   7,   6,   0,   5,   0,   4,   3,
              0,   2,   0,
  /*   1 */   0,
  /*   2 */   0,
  /*   3 */   0,   2,   0,
  /*   4 */   0,   5,
  /*   5 */   0,
  /*   6 */   0,   7,   0,   7,   0,   7,   0,   7,   0,   7,
              0,   7,   0,   7,   0,   7,   0,   7,   0,
  /*   7 */   0,   8,   0,   8,   0,   8,  15,   8,   0,   8,
             14,   8,   0,
  /*   8 */   0,   9,   0,   9,   0,   9,  17,   9,  16,   9,
              0,   9,   0,
  /*   9 */   0,
  /*  10 */   0,  11,   0,
  /*  11 */   0,  12,   0,  12,   0,
  /*  12 */   0,  13,   0,  13,   0,  18,   0,
  /*  13 */   0,
  /*  14 */   0,   8,   0,   8,   0,   8,   0,   8,   0,  19,
              8,   0,   8,   0,  19,   0,   8,   0,   8,   0,
  /*  15 */   0,
  /*  16 */   0,   9,   0,   9,   0,   9,   0,   9,   0,  20,
              9,   0,   9,   0,  20,   0,   9,   0,   9,   0,
  /*  17 */   0,  18,   0,
  /*  18 */   0,   8,   0,   8,   0,
  /*  19 */   0,   9,   0,   9,   0
};

static string Tokens[12] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Page",
  "Etx",
  "Parenthesis",
  "Comment",
  "Ide",
  "Nat",
  "Opr",
  "Set",
  "Seq"
};

static byte Flags[12] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "estyx", /* Name    */
  20,      /* States  */
  12,      /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_estyx(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
}
