/* [styx_lim.c] Scanner table for 'styx'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[91] =
/* first edge per state */
{
    0,  34,  35,  36,  39,  41,  42,  61,  74,  99,
  113, 114, 117, 122, 129, 130, 154, 159, 164, 167,
  170, 185, 186, 212, 215, 220, 225, 228, 231, 236,
  239, 242, 243, 256, 269, 293, 298, 303, 308, 311,
  312, 315, 318, 321, 324, 329, 334, 337, 340, 343,
  348, 353, 361, 364, 372, 377, 382, 396, 399, 402,
  416, 419, 424, 429, 438, 446, 466, 471, 476, 487,
  490, 502, 505, 522, 526, 531, 536, 539, 556, 564,
  576, 579, 589, 595, 601, 604, 610, 616, 617, 623,
  629
};

static short StaFin[90] =
/* finite token per state */
{
    0,   2,   3,   0,   4,   1,   9,   0,   9,   0,
    5,   8,   6,   7,  11,   0,   0,   0,   0,  14,
   14,  10,  14,   7,   0,   0,   0,   0,   0,   0,
    0,  14,   0,  14,   0,   0,   0,   0,   0,  15,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,  15,   0,  13,   0,   0,   0,   0,
   13,   0,   0,   0,   0,  12,   0,   0,   0,   0,
    0,  13,   0,   0,   0,   0,   0,  13,   0,   0
};

static wc_char EdgeC[629] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        255,        128,        127,        126,        125,        124,        123,         97,
                    96,         94,         93,         92,         91,         65,         60,         59,
                    58,         48,         42,         40,         39,         36,         35,         34,
                    33,         32,         27,         26,         14,         13,         12,         11,
                    10,          0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */         11,         10,          0,
  /*   4 */        256,          0,
  /*   5 */          0,
  /*   6 */        255,        128,        127,        126,        125,        124,         96,         94,
                    65,         60,         59,         58,         48,         42,         39,         35,
                    34,         33,          0,
  /*   7 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*   8 */        255,        128,        127,        126,        125,        124,        110,        109,
                   106,        105,        102,        101,         96,         94,         65,         60,
                    59,         58,         48,         42,         39,         35,         34,         33,
                     0,
  /*   9 */        256,        255,        128,        127,         97,         96,         93,         92,
                    40,         39,         35,         34,         32,          0,
  /*  10 */          0,
  /*  11 */         58,         48,          0,
  /*  12 */        255,        128,        127,         32,          0,
  /*  13 */        123,         97,         91,         65,         58,         48,          0,
  /*  14 */          0,
  /*  15 */        121,        120,        117,        116,        115,        114,        113,        112,
                   111,        110,        103,         97,         96,         93,         92,         89,
                    88,         58,         48,         40,         39,         35,         34,          0,
  /*  16 */        111,        110,        109,        108,          0,
  /*  17 */        111,        110,        103,        102,          0,
  /*  18 */         98,         97,          0,
  /*  19 */         46,         45,          0,
  /*  20 */        255,        128,        127,         97,         96,         93,         92,         46,
                    45,         40,         39,         35,         34,         32,          0,
  /*  21 */          0,
  /*  22 */        121,        120,        117,        116,        115,        114,        113,        112,
                   111,        110,        103,         97,         96,         93,         92,         89,
                    88,         58,         48,         46,         45,         40,         39,         35,
                    34,          0,
  /*  23 */         58,         48,          0,
  /*  24 */        103,         97,         58,         48,          0,
  /*  25 */        103,         97,         58,         48,          0,
  /*  26 */        116,        115,          0,
  /*  27 */        101,        100,          0,
  /*  28 */        111,        110,        101,        100,          0,
  /*  29 */        100,         99,          0,
  /*  30 */        100,         99,          0,
  /*  31 */          0,
  /*  32 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*  33 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*  34 */        121,        120,        117,        116,        115,        114,        113,        112,
                   111,        110,        103,         97,         96,         93,         92,         89,
                    88,         58,         48,         40,         39,         35,         34,          0,
  /*  35 */        103,         97,         58,         48,          0,
  /*  36 */        103,         97,         58,         48,          0,
  /*  37 */        103,         97,         58,         48,          0,
  /*  38 */        102,        101,          0,
  /*  39 */          0,
  /*  40 */        102,        101,          0,
  /*  41 */        101,        100,          0,
  /*  42 */        109,        108,          0,
  /*  43 */        115,        114,          0,
  /*  44 */        103,         97,         58,         48,          0,
  /*  45 */        103,         97,         58,         48,          0,
  /*  46 */        103,        102,          0,
  /*  47 */        118,        117,          0,
  /*  48 */        112,        111,          0,
  /*  49 */        103,         97,         58,         48,          0,
  /*  50 */        103,         97,         58,         48,          0,
  /*  51 */         33,         32,         14,         13,         12,         11,         10,          0,
  /*  52 */        101,        100,          0,
  /*  53 */         33,         32,         14,         13,         12,         11,         10,          0,
  /*  54 */        103,         97,         58,         48,          0,
  /*  55 */        103,         97,         58,         48,          0,
  /*  56 */        123,         97,         96,         95,         91,         65,         33,         32,
                    14,         13,         12,         11,         10,          0,
  /*  57 */         11,         10,          0,
  /*  58 */        102,        101,          0,
  /*  59 */        123,         97,         96,         95,         91,         65,         33,         32,
                    14,         13,         12,         11,         10,          0,
  /*  60 */         11,         10,          0,
  /*  61 */        103,         97,         58,         48,          0,
  /*  62 */        103,         97,         58,         48,          0,
  /*  63 */        123,         97,         96,         95,         91,         65,         58,         48,
                     0,
  /*  64 */         33,         32,         14,         13,         12,         11,         10,          0,
  /*  65 */        123,         97,         96,         95,         91,         65,         62,         61,
                    58,         48,         41,         40,         33,         32,         14,         13,
                    12,         11,         10,          0,
  /*  66 */        103,         97,         58,         48,          0,
  /*  67 */        103,         97,         58,         48,          0,
  /*  68 */        255,        128,        127,         33,         32,         14,         13,         12,
                    11,         10,          0,
  /*  69 */         11,         10,          0,
  /*  70 */         62,         61,         41,         40,         33,         32,         14,         13,
                    12,         11,         10,          0,
  /*  71 */         11,         10,          0,
  /*  72 */        255,        128,        127,         62,         61,         45,         44,         42,
                    41,         33,         32,         14,         13,         12,         11,         10,
                     0,
  /*  73 */        256,         36,         35,          0,
  /*  74 */        103,         97,         58,         48,          0,
  /*  75 */        255,        128,        127,         33,          0,
  /*  76 */         11,         10,          0,
  /*  77 */        255,        128,        127,         62,         61,         45,         44,         42,
                    41,         33,         32,         14,         13,         12,         11,         10,
                     0,
  /*  78 */        256,        110,        109,        102,        101,         36,         35,          0,
  /*  79 */         45,         44,         42,         41,         33,         32,         14,         13,
                    12,         11,         10,          0,
  /*  80 */         11,         10,          0,
  /*  81 */         62,         61,         33,         32,         14,         13,         12,         11,
                    10,          0,
  /*  82 */        256,        111,        110,         36,         35,          0,
  /*  83 */        256,         98,         97,         36,         35,          0,
  /*  84 */         11,         10,          0,
  /*  85 */        256,        101,        100,         36,         35,          0,
  /*  86 */        256,        100,         99,         36,         35,          0,
  /*  87 */          0,
  /*  88 */        256,        115,        114,         36,         35,          0,
  /*  89 */        256,        112,        111,         36,         35,          0
};

static short EdgeS[629] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   7,   0,   7,  11,   7,  11,  14,   0,   7,
             11,   0,  11,  14,   7,  13,   7,  12,   7,  11,
             10,   7,   9,   8,   7,   6,   0,   5,   0,   4,
              3,   0,   2,   0,
  /*   1 */   0,
  /*   2 */   0,
  /*   3 */   0,   2,   0,
  /*   4 */   0,   5,
  /*   5 */   0,
  /*   6 */   0,   7,   0,   7,   0,   7,   0,   7,   0,   7,
              0,   7,   0,   7,   0,   7,   0,   7,   0,
  /*   7 */   0,   8,   0,   8,   0,   8,  16,   8,   0,   8,
             15,   8,   0,
  /*   8 */   0,   7,   0,   7,   0,   7,   0,  19,   0,  18,
              0,  17,   0,   7,   0,   7,   0,   7,   0,   7,
              0,   7,   0,   7,   0,
  /*   9 */   0,  20,  21,  20,  21,  20,  21,  23,  21,  22,
             21,  20,  21,  20,
  /*  10 */   0,
  /*  11 */   0,  12,   0,
  /*  12 */   0,  13,   0,  13,   0,
  /*  13 */   0,  14,   0,  14,   0,  24,   0,
  /*  14 */   0,
  /*  15 */   0,  26,   0,   8,   0,   8,   0,   8,   0,   8,
              0,  25,   8,   0,   8,   0,  26,   0,  25,   0,
              8,   0,   8,   0,
  /*  16 */   0,  28,   0,  27,   0,
  /*  17 */   0,  30,   0,  29,   0,
  /*  18 */   0,  31,   0,
  /*  19 */   0,  32,   0,
  /*  20 */   0,  33,   0,  33,   0,  33,  35,  33,  34,  33,
             22,  33,   0,  33,   0,
  /*  21 */   0,
  /*  22 */   0,  37,   0,  33,   0,  33,   0,  33,   0,  33,
              0,  36,  33,   0,  33,   0,  37,   0,  36,   0,
             32,   0,  33,   0,  33,   0,
  /*  23 */   0,  24,   0,
  /*  24 */   0,   8,   0,   8,   0,
  /*  25 */   0,  38,   0,  38,   0,
  /*  26 */   0,  39,   0,
  /*  27 */   0,  40,   0,
  /*  28 */   0,  42,   0,  41,   0,
  /*  29 */   0,  43,   0,
  /*  30 */   0,  44,   0,
  /*  31 */   0,
  /*  32 */   0,  33,   0,  33,   0,  33,  35,  33,  22,  33,
              0,  33,   0,
  /*  33 */   0,  33,   0,  33,   0,  33,  35,  33,  22,  33,
              0,  33,   0,
  /*  34 */   0,  37,   0,  33,   0,  33,   0,  33,   0,  33,
              0,  36,  33,   0,  33,   0,  37,   0,  36,   0,
             33,   0,  33,   0,
  /*  35 */   0,  33,   0,  33,   0,
  /*  36 */   0,  45,   0,  45,   0,
  /*  37 */   0,  46,   0,  46,   0,
  /*  38 */   0,  40,   0,
  /*  39 */   0,
  /*  40 */   0,  47,   0,
  /*  41 */   0,  41,   0,
  /*  42 */   0,  48,   0,
  /*  43 */   0,  49,   0,
  /*  44 */   0,  50,   0,  50,   0,
  /*  45 */   0,  51,   0,  51,   0,
  /*  46 */   0,  52,   0,
  /*  47 */   0,  53,   0,
  /*  48 */   0,  54,   0,
  /*  49 */   0,  55,   0,  55,   0,
  /*  50 */   0,  56,   0,  56,   0,
  /*  51 */   0,  57,   0,  58,  57,   0,  57,   0,
  /*  52 */   0,  59,   0,
  /*  53 */   0,  60,   0,  61,  60,   0,  60,   0,
  /*  54 */   0,  62,   0,  62,   0,
  /*  55 */   0,  63,   0,  63,   0,
  /*  56 */   0,  64,   0,  64,   0,  64,   0,  57,   0,  58,
             57,   0,  57,   0,
  /*  57 */   0,  57,   0,
  /*  58 */   0,  65,   0,
  /*  59 */   0,  66,   0,  66,   0,  66,   0,  60,   0,  61,
             60,   0,  60,   0,
  /*  60 */   0,  60,   0,
  /*  61 */   0,  67,   0,  67,   0,
  /*  62 */   0,  68,   0,  68,   0,
  /*  63 */   0,  64,   0,  64,   0,  64,   0,  64,   0,
  /*  64 */   0,  69,   0,  70,  69,   0,  69,   0,
  /*  65 */   0,  66,   0,  66,   0,  66,   0,  74,   0,  66,
              0,  73,   0,  71,   0,  72,  71,   0,  71,   0,
  /*  66 */   0,  75,   0,  75,   0,
  /*  67 */   0,  25,   0,  25,   0,
  /*  68 */   0,  76,   0,  76,  69,   0,  70,  69,   0,  69,
              0,
  /*  69 */   0,  69,   0,
  /*  70 */   0,  74,   0,  73,   0,  71,   0,  72,  71,   0,
             71,   0,
  /*  71 */   0,  71,   0,
  /*  72 */   0,  78,   0,  78,   0,  78,   0,  78,   0,  78,
             73,   0,  77,  73,   0,  73,   0,
  /*  73 */   0,  74,  79,  74,
  /*  74 */   0,  36,   0,  36,   0,
  /*  75 */   0,  76,   0,  76,   0,
  /*  76 */   0,  73,   0,
  /*  77 */   0,  78,   0,  78,   0,  78,  73,  78,  82,  78,
             80,   0,  81,  80,   0,  80,   0,
  /*  78 */   0,  74,  84,  74,  83,  74,  79,  74,
  /*  79 */   0,  73,   0,  82,   0,  80,   0,  81,  80,   0,
             80,   0,
  /*  80 */   0,  80,   0,
  /*  81 */   0,  74,   0,  82,   0,  85,  82,   0,  82,   0,
  /*  82 */   0,  74,  86,  74,  79,  74,
  /*  83 */   0,  74,  87,  74,  79,  74,
  /*  84 */   0,  82,   0,
  /*  85 */   0,  74,  88,  74,  79,  74,
  /*  86 */   0,  74,  89,  74,  79,  74,
  /*  87 */   0,
  /*  88 */   0,  74,  90,  74,  79,  74,
  /*  89 */   0,  74,   0,  74,  79,  74
};

static string Tokens[16] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Page",
  "Etx",
  "Parenthesis",
  "Comment",
  "Ide",
  "Nat",
  "Opr",
  "Set",
  "Seq",
  "MacInc",
  "MacDfn",
  "MacSep",
  "MacCond"
};

static byte Flags[16] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "styx", /* Name    */
  90,     /* States  */
  16,     /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_styx(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
}
