# [stydoc.cmd] command description for stydoc.c

Program stydoc -- STYX Documentation Generator

doc
  <p>'stydoc' produces a HTML-like reference documentation for a STYX grammar [.sty].
  <br>
  <p>Comments which don't begin with ';;' will also be included.
cod

Arguments

  InFile   : path -- path of the STYX grammar [.sty]
  OutFile  : path -- path of the target file

Options

  StyxPath : path = "."       -- path of STYX grammar include files
  Template : path = "/p/styx/pat/tstydoc_us.htm" -- path of the template file
  RefAlias : string = "&amp;" -- alias for the first character of a pattern reference
  recursiv : flag = false     -- recursive pattern evaluation
  prodcom  : flag = false     -- print production comments
  keepNTs  : string = ""      -- NTs which shouldn't be expanded ( NT ; ... )
  noClass  : string = ""      -- split NT Classes ( NT ; ... )
  exProds  : string = ""      -- hide NT Productions ( NT . Prod ; ... )
  ignRRef  : string = ""      -- ignore recursive references ( NT ; ... )

Environment

  PATH     : path -- search path for the parse table image [.pim]
