# [styx.cmd] command description for [styx.c]

Program styx -- A combined parser and scanner generator

doc
  <p>'styx' translates the token and syntax description for a language in [$SPESTYX/Language.sty] 
  into scanner and parser tables and a functional interface to the abstract derivation tree.
  <br>
  <p>The generated tables have to be applied to the actual scanner and parser function which are part of the 
  styx library. The result of the parser function will be a derivation tree which can be accessed through 
  the above mentioned interface.
cod

Arguments

  Language  : name        -- language name

Options

  diagnose : flag = false -- additional diagnose and information
  verbose  : flag = false -- progress information

  makeIMG  : flag = false -- create binary table images
  makeINT  : flag = false -- create interface c source
  makeC    : flag = false -- create table c sources

doc
  <p>Dependant on the given options different source and image files will be created: 

  <ol>
  <li><b>-makeIMG</b><br>
      For an interpretative execution you may only need the binary
      [$BINSTYX/Language.pim] and [$BINSTYX/Language.lim] image files which 
      contain the parser and scanner tables.

  <li><b>-makeINT</b><br>
      To process the derivation tree within your c/c++ program its useful to 
      create the interface c source [$GENSTYX/Language(1,4)_int.c].

  <li><b>-makeC</b><br>
      Instead of using the table image files you can include the c sources
      [$GENSTYX/Language(1,4)_pim.c] and [$GENSTYX/Language(1,4)_lim.c] in your compiler.
      This option implies '-makeINT'.
  </ol>
cod

Environment

  BINSTYX : path = "."     -- [.pim] und [.lim] target directory
  GENSTYX : path = "."     -- [.c] target directory
  SPESTYX : path = "."     -- [.sty] source directory
